
try:
	import psyco
	print 'Imported pscyo.'
except:	print 'Failed to import psyco.'

import csnd
import CsoundAC
import thread
import threading

##################################################################
class Process(threading._Timer):
    def __init__(self, *args, **kwargs):
        threading._Timer.__init__(self, *args, **kwargs)
        self.setDaemon(True)

    def run(self):
        while True:
            self.finished.clear()
            self.finished.wait(self.interval)
            if not self.finished.isSet():
                self.function(*self.args, **self.kwargs)
            else:
                return
            self.finished.set()

##################################################################
class ProcessManager(object):

    ops = []

    def add_process(self, process, interval, args=[], kwargs={}):
        op = Process(interval, process, args, kwargs)
        self.ops.append(op)
        thread.start_new_thread(op.run, ())

    def stop(self):
        for op in self.ops:
            op.cancel()
        self._event.set()


##################################################################
def playnote():
    print "playing note!"
    message = 'i	1	0	.5'
    csound.inputMessage(message)

##################################################################
def startperf():
    print "starting csound performance..."
    csound.perform()
	

##################################################################
    
#our process manager, handles periodic events	
procman = ProcessManager()

# Create an instance of Csound.
csound = csnd.CppSound()

# Enable Csound to print console messages 
# to the Python console.

csound.setPythonMessageCallback()

csound.load('pytest3.csd')

csound.setCommand('csound temp.orc temp.sco')

# Print the complete .csd file.

print csound.getCSD()

# Export the .orc and .sco file for performance.

csound.exportForPerformance()

# start csound performance, making interval very long, needs to be one time only
procman.add_process(startperf, 100000)  

procman.add_process(playnote, 1)
